"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getParamValue = void 0;
var Params;
(function (Params) {
    Params["ExpressRequest"] = "express.request";
    Params["ExpressResponse"] = "express.response";
    Params["ExpressNext"] = "express.next";
})(Params || (Params = {}));
var getParamValue = function (name, req, res, next) {
    switch (name) {
        case Params.ExpressRequest:
            return req;
        case Params.ExpressResponse:
            return res;
        case Params.ExpressNext:
            return next;
        default:
            return undefined;
    }
};
exports.getParamValue = getParamValue;
exports.default = Params;
//# sourceMappingURL=Params.js.map