"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable require-jsdoc */
var express_rate_limit_1 = __importDefault(require("express-rate-limit"));
var async_lock_1 = __importDefault(require("async-lock"));
var path_1 = __importDefault(require("path"));
var re2_1 = __importDefault(require("re2"));
var fs_1 = __importDefault(require("fs"));
var express_1 = __importStar(require("express"));
var Injector_1 = require("../Injector");
var utils_1 = require("../utils");
var ExpressTS_1 = __importDefault(require("../app/ExpressTS"));
var Params_1 = require("./Params");
var Configuration_1 = require("../Configuration");
var Router = /** @class */ (function () {
    function Router() {
        var _a, _b, _c, _d;
        this.subdomainMiddleware = function (subdomain, fn) { return function (req, res, next) {
            var _a;
            var host = (_a = req.headers.host) === null || _a === void 0 ? void 0 : _a.toString().split(':')[0];
            if (!host) {
                return next();
            }
            var subdomains = host
                .split('.')
                .filter(function (x) { return !!x && x.toString().trim() !== ''; });
            if (subdomains.join('.').trim().startsWith(subdomain.toString().trim())) {
                return fn(req, res, next);
            }
            else {
                return next();
            }
        }; };
        this.lock = new async_lock_1.default();
        if (!((_a = this.config) === null || _a === void 0 ? void 0 : _a.rootFile) || !((_b = this.config) === null || _b === void 0 ? void 0 : _b.apiPrefix)) {
            throw new Error('The configuration is not Injected!');
        }
        if (!this.application) {
            throw new Error('The express application is not Injected!');
        }
        this.errorHandler = (_c = this.config.errorHandler) !== null && _c !== void 0 ? _c : Configuration_1.defaultErrorHandler;
        this.notFoundHandler =
            (_d = this.config.notFoundHandler) !== null && _d !== void 0 ? _d : Configuration_1.defaultNotFoundHandler;
        this.injectMiddlewares();
        this.injectResponders();
        this.injectEntities();
        this.injectDomains();
        this.injectActions(this.getAbsolutePath('actions'), '');
        var isSamePath = this.isApiTheSameAsStatic();
        if (!isSamePath) {
            this.injectPathErrors();
        }
        this.injectAllStaticFiles();
        if (isSamePath) {
            this.injectPathErrors();
        }
        this.injectStaticFilesPathErrors();
    }
    Router.prototype.debugLog = function () {
        var _a, _b;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var empty = function () { };
        ((_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.debug.log) !== null && _b !== void 0 ? _b : empty).apply(void 0, args);
    };
    Router.prototype.debugError = function () {
        var _a, _b;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var empty = function () { };
        ((_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.debug.error) !== null && _b !== void 0 ? _b : empty).apply(void 0, args);
    };
    Router.prototype.getAbsolutePath = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return path_1.default.join.apply(null, __spreadArray([
            path_1.default.dirname(this.config.rootFile)
        ], args));
    };
    Object.defineProperty(Router.prototype, "APIPrefix", {
        get: function () {
            var _a;
            if (!((_a = this.config) === null || _a === void 0 ? void 0 : _a.apiPrefix)) {
                throw new Error('The configuration is not Injected!');
            }
            var prefix = this.config.apiPrefix;
            return prefix.startsWith('/') ? prefix : "/" + prefix;
        },
        enumerable: false,
        configurable: true
    });
    Router.prototype.isValidFile = function (fileName) {
        if (path_1.default.extname(fileName) === path_1.default.extname(this.config.rootFile)) {
            return true;
        }
        return false;
    };
    Router.prototype.injectMiddlewares = function () {
        var _this = this;
        if (this.middlewares) {
            this.middlewares.map(function (middleware) {
                if (!_this.lock) {
                    throw new Error('The async-lock instance is not created!');
                }
                _this.lock.acquire('app-middleware-injector', function (done) {
                    var _a, _b;
                    try {
                        if (typeof middleware === 'string') {
                            var mid_1 = Injector_1.Injector.get(middleware);
                            if (mid_1) {
                                _this.debugLog('Global Middleware loaded %o', middleware);
                                (_a = _this.application) === null || _a === void 0 ? void 0 : _a.use(utils_1.HandleMiddleware(utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, mid_1.middleware(req, res, next)];
                                            case 1: return [2 /*return*/, _a.sent()];
                                        }
                                    });
                                }); }, _this.errorHandler), _this.APIPrefix, 'api'));
                            }
                        }
                        else if (typeof middleware === 'function') {
                            _this.debugLog('Global Middleware loaded %o', middleware.name);
                            (_b = _this.application) === null || _b === void 0 ? void 0 : _b.use(utils_1.HandleMiddleware(utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, middleware(req, res, next)];
                                        case 1: return [2 /*return*/, _a.sent()];
                                    }
                                });
                            }); }, _this.errorHandler), _this.APIPrefix, 'api'));
                        }
                    }
                    catch (_c) { }
                    done();
                });
            });
        }
    };
    Router.prototype.injectEntities = function () {
        var _this = this;
        if (!fs_1.default.existsSync(this.getAbsolutePath('domain', 'entities'))) {
            return;
        }
        fs_1.default.readdirSync(this.getAbsolutePath('domain', 'entities')).map(function (name) {
            if (!_this.isValidFile(name)) {
                return;
            }
            try {
                var ent = void 0;
                try {
                    ent = require(_this.getAbsolutePath('domain', 'entities', name));
                }
                catch (e) {
                    _this.debugError(e);
                    return;
                }
                if (!(ent === null || ent === void 0 ? void 0 : ent.default) || !_this.lock) {
                    return;
                }
                var target = ent.default;
                if (ExpressTS_1.default.getInjectedField(target, 'type') !== 'class' ||
                    !ExpressTS_1.default.getInjectedField(target, 'name')) {
                    return;
                }
                var entityName = ExpressTS_1.default.getData(ExpressTS_1.default.getInjectedField(target, 'name'), 'entities');
                if (!entityName) {
                    return;
                }
                _this.debugLog('Entity loaded %o', entityName);
                Injector_1.Injector.inject("Entity." + entityName, target);
            }
            catch (e) {
                _this.debugError(e);
            }
        });
    };
    Router.prototype.injectDomains = function () {
        var _this = this;
        if (!fs_1.default.existsSync(this.getAbsolutePath('domain'))) {
            return;
        }
        fs_1.default.readdirSync(this.getAbsolutePath('domain')).map(function (name) {
            if (!_this.isValidFile(name)) {
                return;
            }
            try {
                var dom = void 0;
                try {
                    dom = require(_this.getAbsolutePath('domain', name));
                }
                catch (e) {
                    _this.debugError(e);
                    return;
                }
                if (!(dom === null || dom === void 0 ? void 0 : dom.default) || !_this.lock) {
                    return;
                }
                var target = dom.default;
                if (ExpressTS_1.default.getInjectedField(target, 'type') !== 'class' ||
                    !ExpressTS_1.default.getInjectedField(target, 'name')) {
                    return;
                }
                var domainName = ExpressTS_1.default.getData(ExpressTS_1.default.getInjectedField(target, 'name'), 'domains');
                if (!domainName) {
                    return;
                }
                _this.debugLog('Domain loaded %o', domainName);
                Injector_1.Injector.inject("Domain." + domainName, target);
            }
            catch (e) {
                _this.debugError(e);
            }
        });
    };
    Router.prototype.injectResponders = function () {
        var _this = this;
        if (!fs_1.default.existsSync(this.getAbsolutePath('responders'))) {
            return;
        }
        fs_1.default.readdirSync(this.getAbsolutePath('responders')).map(function (name) {
            if (!_this.isValidFile(name)) {
                return;
            }
            try {
                var resp = void 0;
                try {
                    resp = require(_this.getAbsolutePath('responders', name));
                }
                catch (e) {
                    _this.debugError(e);
                    return;
                }
                if (!(resp === null || resp === void 0 ? void 0 : resp.default) || !_this.lock) {
                    return;
                }
                var target = resp.default;
                if (ExpressTS_1.default.getInjectedField(target, 'type') !== 'class' ||
                    !ExpressTS_1.default.getInjectedField(target, 'name')) {
                    return;
                }
                var responderName = ExpressTS_1.default.getData(ExpressTS_1.default.getInjectedField(target, 'name'), 'responders');
                _this.debugLog('Responder loaded %o', responderName);
                Injector_1.Injector.inject("Responder." + responderName, target);
            }
            catch (e) {
                _this.debugError(e);
            }
        });
    };
    Router.prototype.injectActions = function (actionsPathRoot, actionsPrefix) {
        var _this = this;
        if (!fs_1.default.existsSync(actionsPathRoot)) {
            return;
        }
        fs_1.default.readdirSync(actionsPathRoot).map(function (name) {
            var _a, _b, _c;
            var actionPath = path_1.default.join(actionsPathRoot, name);
            try {
                if (!_this.lock) {
                    return;
                }
                var isDir = fs_1.default.lstatSync(actionPath).isDirectory();
                if (isDir) {
                    var dirName = path_1.default.basename(actionPath);
                    _this.injectActions(actionPath, dirName.startsWith('/') ? dirName : "/" + dirName);
                    return;
                }
                if (!_this.isValidFile(actionPath)) {
                    return;
                }
                var ac = require(actionPath);
                if (!ac || !ac.default) {
                    return;
                }
                var target = ac.default;
                var targetName = ExpressTS_1.default.getInjectedField(target, 'name');
                if (ExpressTS_1.default.getInjectedField(target, 'type') !== 'action' ||
                    !targetName) {
                    return;
                }
                var action_1 = ExpressTS_1.default.getData(targetName, 'actions');
                var funcParams_1 = (_a = ExpressTS_1.default.getData(targetName, 'functionParams')) !== null && _a !== void 0 ? _a : [];
                if (!(action_1 === null || action_1 === void 0 ? void 0 : action_1.target) || ((_b = action_1 === null || action_1 === void 0 ? void 0 : action_1.functions) === null || _b === void 0 ? void 0 : _b.length) <= 0) {
                    return;
                }
                if (!_this.application || !_this.config) {
                    return;
                }
                var searchRegExp_1 = new re2_1.default('//', 'gm');
                var apiPath_1 = [_this.APIPrefix, actionsPrefix, (_c = action_1.path) !== null && _c !== void 0 ? _c : '']
                    .join('')
                    .trim()
                    .replace(searchRegExp_1, '/');
                if ((apiPath_1 === null || apiPath_1 === void 0 ? void 0 : apiPath_1.trim()) === '' || !(action_1 === null || action_1 === void 0 ? void 0 : action_1.path)) {
                    return;
                }
                var router_1 = express_1.Router();
                if (action_1.middlewares && Array.isArray(action_1.middlewares)) {
                    action_1.middlewares.map(function (middleware) {
                        if (!_this.lock) {
                            return;
                        }
                        _this.lock.acquire('app-middleware-injector', function (done) {
                            try {
                                if (typeof middleware === 'string') {
                                    var mid_2 = Injector_1.Injector.get(middleware);
                                    if (mid_2) {
                                        _this.debugLog('Action Middleware loaded %o', middleware);
                                        router_1.use(utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, mid_2.middleware(req, res, next)];
                                                    case 1: return [2 /*return*/, _a.sent()];
                                                }
                                            });
                                        }); }, _this.errorHandler));
                                    }
                                }
                                else if (typeof middleware === 'function') {
                                    _this.debugLog('Action Middleware loaded %o', middleware.name);
                                    router_1.use(utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, middleware(req, res, next)];
                                                case 1: return [2 /*return*/, _a.sent()];
                                            }
                                        });
                                    }); }, _this.errorHandler));
                                }
                            }
                            catch (_a) { }
                            done();
                        });
                    });
                }
                action_1.functions.map(function (functionData) {
                    var _a;
                    if (!router_1[functionData.method] ||
                        typeof router_1[functionData.method] !== 'function') {
                        return;
                    }
                    var child = (_a = functionData.child) !== null && _a !== void 0 ? _a : '';
                    child = child.startsWith('/') ? child : "/" + child;
                    var paramsInfoRaw = funcParams_1
                        .filter(function (x) { return !!x && !!functionData && x.name === functionData.name; })
                        .sort(function (a, b) { return a.index - b.index; });
                    var paramsInfo = [];
                    paramsInfoRaw.map(function (_a) {
                        var paramPosition = _a.index, paramTarget = _a.target;
                        paramsInfo[parseInt(paramPosition)] = paramTarget;
                    });
                    var middlewares = [];
                    if (functionData.middlewares &&
                        Array.isArray(functionData.middlewares)) {
                        middlewares = functionData.middlewares
                            .map(function (middleware) {
                            var ret;
                            try {
                                if (typeof middleware === 'string') {
                                    var mid_3 = Injector_1.Injector.get(middleware);
                                    if (mid_3) {
                                        _this.debugLog('Method Middleware loaded %o', middleware);
                                        ret = utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, mid_3.middleware(req, res, next)];
                                                    case 1: return [2 /*return*/, _a.sent()];
                                                }
                                            });
                                        }); }, _this.errorHandler);
                                    }
                                }
                                else if (typeof middleware === 'function') {
                                    _this.debugLog('Method Middleware loaded %o', middleware.name);
                                    ret = utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, middleware(req, res, next)];
                                                case 1: return [2 /*return*/, _a.sent()];
                                            }
                                        });
                                    }); }, _this.errorHandler);
                                }
                            }
                            catch (_a) { }
                            return ret;
                        })
                            .filter(function (middleware) { return !!middleware; });
                    }
                    middlewares = __spreadArray(__spreadArray([], middlewares), [
                        utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                            var params;
                            var _a;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        params = paramsInfo.map(function (paramName) {
                                            return Params_1.getParamValue(paramName, req, res, next);
                                        });
                                        return [4 /*yield*/, (_a = action_1.instance)[functionData.name].apply(_a, params)];
                                    case 1:
                                        _b.sent();
                                        if (!res.headersSent) {
                                            res.status(500).json({
                                                success: false,
                                                message: 'No response was added for this route'
                                            });
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        }); }, _this.errorHandler)
                    ]);
                    router_1[functionData.method].apply(router_1, __spreadArray([child], middlewares));
                    _this.debugLog('Action loaded %o %s %o', functionData.method.toUpperCase(), ("" + apiPath_1 + child)
                        .trim()
                        .replace(searchRegExp_1, '/')
                        .replace(new re2_1.default('/$', 'gm'), ''), functionData.name);
                });
                _this.lock.acquire('app-middleware-injector', function (done) {
                    var _a;
                    try {
                        (_a = _this.application) === null || _a === void 0 ? void 0 : _a.use(apiPath_1, router_1);
                    }
                    catch (_b) { }
                    done();
                });
            }
            catch (e) {
                _this.debugError(e);
            }
        });
    };
    Router.prototype.isApiTheSameAsStatic = function () {
        var _a;
        var check = false;
        if (((_a = this.config) === null || _a === void 0 ? void 0 : _a.staticFiles) && this.getAbsolutePath) {
            var staticFiles = this.config.staticFiles;
            if (!Array.isArray(staticFiles) &&
                this.staticFilesPath(staticFiles).includes(this.APIPrefix) &&
                staticFiles.disableIndexRouter) {
                check = !!staticFiles.disableIndexRouter;
            }
        }
        return check;
    };
    Router.prototype.injectPathErrors = function () {
        var _this = this;
        var _a;
        try {
            (_a = this.lock) === null || _a === void 0 ? void 0 : _a.acquire('app-middleware-injector', function (done) {
                var _a;
                try {
                    (_a = _this.application) === null || _a === void 0 ? void 0 : _a.use(_this.APIPrefix, utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.notFoundHandler(req, res, next)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    }); }, _this.errorHandler));
                }
                catch (_b) { }
                done();
            });
        }
        catch (_b) { }
    };
    Router.prototype.injectAllStaticFiles = function () {
        var _this = this;
        var _a;
        if (((_a = this.config) === null || _a === void 0 ? void 0 : _a.staticFiles) && this.getAbsolutePath) {
            var staticFiles = this.config.staticFiles;
            if (!Array.isArray(staticFiles)) {
                this.injectStaticFiles(staticFiles);
            }
            else {
                __spreadArray([], staticFiles).sort(function (sfA, sfB) { var _a, _b, _c, _d; return ((_b = (_a = sfB.subdomain) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) - ((_d = (_c = sfA.subdomain) === null || _c === void 0 ? void 0 : _c.length) !== null && _d !== void 0 ? _d : 0); })
                    .map(function (engine) { return _this.injectStaticFiles(engine); });
            }
        }
    };
    Router.prototype.injectStaticFilesPathErrors = function () {
        var _this = this;
        var _a;
        try {
            (_a = this.lock) === null || _a === void 0 ? void 0 : _a.acquire('app-middleware-injector', function (done) {
                var _a, _b;
                try {
                    (_a = _this.application) === null || _a === void 0 ? void 0 : _a.use('*', utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.notFoundHandler(req, res, next)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    }); }, _this.errorHandler));
                    (_b = _this.application) === null || _b === void 0 ? void 0 : _b.use(function (error, req, res, next) {
                        return _this.errorHandler(req, res, next, error);
                    });
                }
                catch (_c) { }
                done();
            });
        }
        catch (_b) { }
    };
    Router.prototype.staticFilesPath = function (staticFiles) {
        return staticFiles.path.startsWith('/')
            ? staticFiles.path.trim()
            : "/" + staticFiles.path.trim();
    };
    Router.prototype.injectStaticFiles = function (staticFiles) {
        var _this = this;
        var _a, _b, _c;
        var staticPath = this.staticFilesPath(staticFiles);
        if (staticPath.includes(this.APIPrefix)) {
            if (Array.isArray(this.config.staticFiles) ||
                (!Array.isArray(this.config.staticFiles) &&
                    !staticFiles.disableIndexRouter)) {
                throw new Error("The static files path can't include the API prefix!");
            }
        }
        var router = express_1.Router();
        var middlewares = ((_a = staticFiles.middlewares) !== null && _a !== void 0 ? _a : [])
            .map(function (middleware) {
            if (typeof middleware === 'string') {
                var mid_4 = Injector_1.Injector.get(middleware);
                if (!mid_4) {
                    return null;
                }
                _this.debugLog('Static Files Middleware loaded %o', middleware);
                return utils_1.HandleMiddleware(utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, mid_4.middleware(req, res, next)];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    });
                }); }, _this.errorHandler), _this.APIPrefix, 'render');
            }
            else if (typeof middleware === 'function') {
                _this.debugLog('Static Files Middleware loaded %o', middleware.name);
                return utils_1.HandleMiddleware(utils_1.AsyncCallback(function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, middleware(req, res, next)];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    });
                }); }, _this.errorHandler), _this.APIPrefix, 'render');
            }
            return null;
        })
            .filter(function (m) { return !!m; });
        if (staticFiles.rateLimitOptions) {
            middlewares = __spreadArray([
                utils_1.AsyncCallback(express_rate_limit_1.default(staticFiles.rateLimitOptions), this.errorHandler)
            ], middlewares);
        }
        if (middlewares.length > 0) {
            router.use.apply(router, middlewares);
        }
        if (staticFiles.customStaticHandler) {
            router.use(staticFiles.customStaticHandler(this.getAbsolutePath.apply(this, staticFiles.directory)));
        }
        else {
            router.use(express_1.default.static(this.getAbsolutePath.apply(this, staticFiles.directory), staticFiles.options));
        }
        if (!staticFiles.disableIndexRouter) {
            router.get('/*', function (req, res) {
                var _a;
                return res.sendFile(_this.getAbsolutePath.apply(_this, __spreadArray(__spreadArray([], staticFiles.directory), [(_a = staticFiles.indexFileName) !== null && _a !== void 0 ? _a : 'index.html'])));
            });
        }
        try {
            (_b = this.lock) === null || _b === void 0 ? void 0 : _b.acquire('app-middleware-injector', function (done) {
                var _a, _b;
                try {
                    if (!staticFiles.subdomain) {
                        (_a = _this.application) === null || _a === void 0 ? void 0 : _a.use(staticPath, router);
                    }
                    else {
                        (_b = _this.application) === null || _b === void 0 ? void 0 : _b.use(staticPath, _this.subdomainMiddleware(staticFiles.subdomain, router));
                    }
                }
                catch (_c) { }
                done();
            });
        }
        catch (_d) { }
        this.debugLog("Static Files Route loaded %o " + (staticFiles.subdomain ? 'for subdomain %o' : ''), staticFiles.path, (_c = staticFiles.subdomain) !== null && _c !== void 0 ? _c : '');
    };
    __decorate([
        Injector_1.Retrive('Express')
    ], Router.prototype, "application", void 0);
    __decorate([
        Injector_1.Retrive('Configuration')
    ], Router.prototype, "config", void 0);
    __decorate([
        Injector_1.Retrive('Middlewares')
    ], Router.prototype, "middlewares", void 0);
    Router = __decorate([
        Injector_1.Inject
    ], Router);
    return Router;
}());
exports.default = Router;
//# sourceMappingURL=Router.js.map