declare type InjectType = 'class' | 'action';
declare type DataType = 'functionParams' | 'injections' | 'responders' | 'entities' | 'domains' | 'actions';
export default abstract class ExpressTS {
    private static injections;
    private static functionParams;
    private static symbols;
    private static responders;
    private static entities;
    private static domains;
    private static actions;
    private static validateType;
    static inject(target: any, source: Function, type: InjectType): void;
    static getInjectedField(target: any, field: 'name' | 'type'): any;
    static clearInjections(): void;
    static setData(name: string, value: any, type: DataType): null | undefined;
    static getData(name: string | undefined, type: DataType): any;
}
export {};
//# sourceMappingURL=ExpressTS.d.ts.map